﻿local GetPlayerMapPosition = GetPlayerMapPosition;
local SpellName = GetSpellInfo(102116);
local CancelUnitBuff = CancelUnitBuff;
local UnitAura = UnitAura;
local AddonName = ...;

local After = C_Timer.After;

local frame = CreateFrame"Frame";
local watch = CreateFrame"Frame";

frame:Hide();
watch:Hide();

local stoped = true;
local enabled = false;

local stop = function()

	CancelUnitBuff("player", SpellName);
	stoped = true;
end

local xPos, yPos;

frame:SetScript("OnUpdate", function(self)

	local newxPos, newyPos = GetPlayerMapPosition"player";

	if newxPos ~= xPos or newyPos ~= yPos then
		After(DarkmoonFaireCannon_Timer2, stop);
		self:Hide();
	end
end);

local frame_on_event = function(self, event, unit)

	if stoped and unit == "player" and UnitAura(unit, SpellName) then
		stoped = false;
		xPos, yPos = GetPlayerMapPosition"player";
		self:Show();
	end
end

watch:SetScript("OnUpdate", function(self, ms) -- next frame

	self:Hide();

	local id = GetCurrentMapAreaID();

	if not enabled and id == 823 then
		enabled = true;
		frame:RegisterEvent"UNIT_AURA";
	elseif enabled and id ~= 823 then
		enabled = false;
		frame:UnregisterEvent"UNIT_AURA";
	end
end);

frame:SetScript("OnEvent", function(self, _, addon)

	if addon ~= AddonName then
		return;
	end

	self:UnregisterEvent"ADDON_LOADED";

	if not DarkmoonFaireCannon_Timer2 or type(DarkmoonFaireCannon_Timer2) ~= "number" then
		DarkmoonFaireCannon_Timer2 = 7.45;
	end

	self:SetScript("OnEvent", frame_on_event);
	watch:SetScript("OnEvent", watch.Show);

	watch:RegisterEvent"ZONE_CHANGED_NEW_AREA";
	watch:Show();
end);

frame:RegisterEvent"ADDON_LOADED";

SlashCmdList.DARKMOONFLAIRECANNON_TIMER = function(new)

	watch:Show();

	if new == "" then
		print(AddonName .. ": current flying time is now " .. DarkmoonFaireCannon_Timer2 .. " second(s)");
		return;
	end

	new = tonumber(new);

	if not new then
		print(AddonName .. ": error, a number (time in seconds) expected!");
		return;
	end

	local old = DarkmoonFaireCannon_Timer2;
	DarkmoonFaireCannon_Timer2 = new;

	print(AddonName .. ": new flying time is now " .. new .. " second(s) (was " .. old .. " second(s))");
end

SLASH_DARKMOONFLAIRECANNON_TIMER1 = "/dmfctimer";
